/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2011  <asgharagha> <email>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "bhv_block.h"
#include <rcsc/geom/vector_2d.h>
#include <rcsc/player/soccer_action.h>
#include <vector>
#include <rcsc/player/player_agent.h>
#include <rcsc/common/server_param.h>
#include <rcsc/common/audio_message.h>
#include <rcsc/common/audio_message.h>
#include <rcsc/player/say_message_builder.h>
#include <rcsc/player/free_message.h>
#include <rcsc/player/intercept_table.h>

int Bhv_Block::tar_unum;
bool Bhv_Block::tar_bool;
Vector2D Bhv_Block::last_pos;
Vector2D Bhv_Block::last_o_pos;
double Bhv_Block::last_o_dir;
bool Bhv_Block::Blockexecute(rcsc::PlayerAgent* agent,rcsc::Vector2D & pos_block)
{
  if (!isBlockMom(agent))
  {
    return false;
  }

  pos_block=calcBlockPos(agent);
  
  /////////////////////////////////////////////////////////////////////
  if(agent->world().ball().velValid() && 
     agent->world().ball().vel().length() > ServerParam::i().ballSpeedMax()/3)
  {
    pos_block += agent->world().ball().vel();
  }
  ////////////////////////////////////////////////////////////////////
  if(last_pos.isValid() && last_pos.absX()<=ServerParam::i().pitchHalfLength() && 
    last_pos.absY()<=ServerParam::i().pitchHalfWidth() && last_o_pos.isValid() && 
    agent->world().opponentsFromBall().at(0)->velValid() &&
    agent->world().opponentsFromBall().at(0)->vel().r()<agent->world().opponentsFromBall().at(0)->playerTypePtr()->realSpeedMax()/3)
  {
    if(agent->world().opponentsFromBall().at(0)->pos().dist2(last_o_pos)< 1 &&  pos_block.dist2(last_pos) <= 2 && 
      fabs(agent->world().opponentsFromBall().at(0)->body().degree() - agent->world().self().body().degree())<60 &&
      agent->world().opponentsFromBall().at(0)->pos().x > -30)
    {

      pos_block=last_pos;

    }
  }

  else
    last_pos=pos_block;

    last_o_pos=agent->world().opponentsFromBall().at(0)->pos();
    last_o_dir=agent->world().opponentsFromBall().at(0)->body().degree();
    
    if(!pos_block.isValid())
      return false;
    
  return true;
  
  
}
bool Bhv_Block::isBlockMom(PlayerAgent* agent)
{
  const  WorldModel & wm = agent->world() ;
  
  if( !wm.self().posValid() )
    return false;
  
  if( !wm.ball().posValid() )
    return false;
    
  if( wm.opponentsFromBall().empty() )
    return false;
  
  if( !wm.opponentsFromBall().front()->posValid() )
    return false;
  
  if( wm.interceptTable()->opponentReachCycle() > wm.interceptTable()->selfReachCycle() + 1 )
    return false;
    
  if( !wm.gameMode().isPenaltyKickMode() )
  {
    if( wm.teammatesFromBall().empty() )
      return false;
    
    if( wm.existKickableTeammate() )
      return false;
    
    if( wm.interceptTable()->opponentReachCycle() > wm.interceptTable()->teammateReachCycle() + 1 )
      return false;
    
    if( wm.self().pos().dist2( wm.opponentsFromBall().front()->pos() ) > 400 )
      return false;
    
    if( ( wm.self().unum() == 2 || wm.self().unum() == 3 ) && wm.ball().pos().x > -23.0 &&
	  wm.self().pos().dist2( wm.opponentsFromBall().front()->pos() ) > 16.0 )
      return false;
    
    if( ( wm.self().unum() == 2 || wm.self().unum() == 3 ) && wm.ball().pos().x > -13.0 &&
	  wm.ball().pos().absY() > 20.0 &&
	  wm.self().pos().dist2( wm.opponentsFromBall().front()->pos() ) > 16.0 )
      return false;
    
    if( ( wm.self().unum() == 4 || wm.self().unum() == 5 ) && wm.ball().pos().x > -15.0 &&
	  wm.self().pos().dist2( wm.opponentsFromBall().front()->pos() ) > 16.0 &&
	  wm.ball().pos().absY() < 20.0 )
      return false;
    
    if( ( wm.self().unum() == 2 || wm.self().unum() == 3 ) && wm.ball().pos().x <= -15.0 &&
	  wm.self().pos().dist2( wm.opponentsFromBall().front()->pos() ) > std::pow( 14.0 , 2.0 ) )
      return false;
    
    if( ( wm.self().unum() == 4 || wm.self().unum() == 5 ) && wm.ball().pos().x > 0.0 &&
      wm.ball().pos().x - wm.ourDefenseLineX() > 5.0 )
      return false;
  }

  return true;
}


bool Bhv_Block::twoBlockersNeeded(PlayerAgent* agent)
{
  const  WorldModel & wm = agent->world() ;
  if(wm.ball().pos().x>-35 || wm.ball().pos().absY()>18)
   return false;
  
  const PlayerPtrCont & offenders = wm.opponentsFromBall();
  const PlayerPtrCont & teammates = wm.teammatesFromBall();
  int o=offenders.size();
  int t=teammates.size();
  int offnumb=0;
  int matenumb=0;
  for(int i=0;i<o;i++)
  {
    if(offenders.at(i)->posValid() && offenders.at(i)->pos().x<-35 && offenders.at(i)->pos().absY()<18)
      offnumb++;
  }
   for(int i=0;i<t;i++)
  {
    if(teammates.at(i)->posValid() && teammates.at(i)->pos().x<-35 && teammates.at(i)->pos().absY()<18)
      matenumb++;
  }
  if (matenumb+1 >= offnumb)
    return true;
  return false;
}


Vector2D Bhv_Block::calcBlockPos(PlayerAgent* agent)
{
  const WorldModel & wm = agent->world();
  
  Vector2D home_pos=Strategy::i().getPosition(wm.self().unum());
   const PlayerObject * opponent_baller = ( wm.existKickableOpponent() ) ?
 					 wm.opponentsFromBall().front() :
 				       ( wm.interceptTable()->fastestOpponent() ) ?
 					 wm.interceptTable()->fastestOpponent() :
 					 wm.opponentsFromBall().front();
  Vector2D opp_pos = opponent_baller->pos() + opponent_baller->vel();
  Vector2D opp_next_pos = opponent_baller->pos() + opponent_baller->vel();
  Vector2D ball_pos = wm.ball().pos();
  Vector2D vec_block = Vector2D::INVALIDATED;
  Vector2D intersectPoint[2];
  Vector2D target_pos = ( penalty_mode ) ? ( wm.ball().inertiaPoint( ( wm.interceptTable()->opponentReachCycle() ) ) ) : opp_pos;

 
  bool bodyval=opponent_baller->bodyValid();
  double markCircleR =fabs( ( -30 - target_pos.absX() ) * opponent_baller->playerTypePtr()->kickableMargin() / 5 );
  double markCircleR_2 = fabs( ( -30 - target_pos.absX() ) * opponent_baller->playerTypePtr()->kickableMargin() / 1 );
  double markCircleR_3 =fabs( ( fabs( target_pos.x - wm.self().pos().x ) + 6.0 ) * opponent_baller->playerTypePtr()->kickableMargin() );
  double markCircleR_4= fabs( ( fabs( target_pos.x - wm.self().pos().x ) + 4.0 ) * opponent_baller->playerTypePtr()->kickableMargin() );
  double markCircleR_5 = fabs( ( -30 - target_pos.absX() ) * opponent_baller->playerTypePtr()->kickableMargin() / 20 );
  double markCircleR_6 = fabs( ( -30 - target_pos.absX() ) * opponent_baller->playerTypePtr()->kickableMargin() / 0.5 );
  double markD = 1.5;
  
  if( wm.self().pos().x > opp_next_pos.x )
  {
    markCircleR += ( wm.self().pos().x - opp_next_pos.x ) * 1.5;
    markCircleR_5 += ( wm.self().pos().x - opp_next_pos.x ) * 1.5;
    markCircleR_2 += ( wm.self().pos().x - opp_next_pos.x ) * 1.5;
    markCircleR_6 += ( wm.self().pos().x - opp_next_pos.x ) * 1.5;
  }
  
  if( wm.countTeammatesIn<Sector2D>( Sector2D( target_pos , 0.6 , 10.0 , 65.0 , -65.0 )  , 6 , false ) == 0 )
  {
    markCircleR += sqrt( wm.self().pos().dist2( ball_pos ) ) * 0.40;
    markCircleR_5 += sqrt( wm.self().pos().dist2( ball_pos ) ) * 0.40;
    markCircleR_6 += sqrt( wm.self().pos().dist2( ball_pos ) ) * 0.40;
  }
  
  markCircleR = std::max( markCircleR , 3.0);
  
  if(target_pos.absY()-wm.self().pos().absY()>1 )
  {
    markCircleR += fabs((target_pos.absY()-wm.self().pos().absY()))/2;
    markCircleR_5 += fabs((target_pos.absY()-wm.self().pos().absY()))/1;
    markCircleR_6 += fabs((target_pos.absY()-wm.self().pos().absY()))/2;
    markCircleR_2 += fabs((target_pos.absY()-wm.self().pos().absY()))/1.5;
  }
  
  Circle2D markCircle( target_pos , markCircleR );
  Circle2D markCircle_2 (target_pos , markCircleR_2) ;
  Circle2D markCircle_3 (target_pos , markCircleR_3);
  Circle2D markCircle_4 (target_pos , markCircleR_4);
  Circle2D markCircle_5 (target_pos , markCircleR_5);
  Circle2D markCircle_6 (target_pos , markCircleR_6);
  Circle2D markCircle_D (target_pos , markD);
 
  Segment2D mark_seg(Vector2D(0,0),Vector2D(-52,0));
  
  Line2D my_y = Line2D( wm.self().pos() , 0.0 );
  
  mark_seg.assign( target_pos , Vector2D(-ServerParam::i().pitchHalfLength(),0) );
  
  Vector2D inter = mark_seg.intersection( my_y ) - Vector2D( 3.0 , 0.0 );
  
  if( inter.x < -52.0 )
    inter.assign( -52.0 , inter.y );
  
  if( inter.isValid() && wm.ball().posValid()  && wm.self().pos().dist2( inter ) > inter.dist2( target_pos ) * 0.5  
    && wm.self().pos().absX() < target_pos.absX()-1 &&( ( target_pos.absX() < 48.0 && wm.ball().pos().absY()>22 )||(target_pos.absX() < 46.0 && wm.ball().pos().absY()>17)  ))
  {
    vec_block = inter;
    return vec_block;
  }
  
   if(target_pos.x<wm.self().pos().x-6 && target_pos.absX()<50 )
    {
      if(target_pos.y<0)
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y+20));
      else
	mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y-20));
      
      if( markCircle_4.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
      {
        vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];

	if(opp_next_pos.x<vec_block.x)
	  vec_block.x -= (opp_next_pos.absX()-vec_block.absX());
	
	return vec_block;
       }
  
        return Strategy::i().getPosition(wm.self().unum());
    }
 
    else if(target_pos.x<wm.self().pos().x-3 && target_pos.x<-35 && target_pos.absX()<50 && target_pos.absY()>20 &&
      
            target_pos.absY()-wm.self().pos().absY() < 6)
    {
      if(wm.opponentsFromBall().at(0)->pos().y<0)
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-3,opp_next_pos.y+15));
      else
	mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-3,opp_next_pos.y-15));
      
       if( markCircle_3.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
      {
        vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];
	
	if(opp_next_pos.x<vec_block.x)
	  vec_block.x -= (opp_next_pos.absX()-vec_block.absX());
	
	return vec_block;
       }
  
        return Strategy::i().getPosition(wm.self().unum());
    }
    
    else if( wm.ball().pos().x < -40.0 && wm.self().pos().absY() > target_pos.absY() )
    {
    if (target_pos.y<0)
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-15,opp_next_pos.y+25));
    else
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-15,opp_next_pos.y-25));
    
         if( markCircle_4.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
           {
             vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];
	   }
	   else
	     vec_block=Strategy::i().getPosition(wm.self().unum());
	   return vec_block;
    }
  
  
  
  else if(target_pos.x>0 && target_pos.absY()>21 && target_pos.y<0)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-7,opp_next_pos.y+8));
  else if(target_pos.x>0 && target_pos.absY()>21 && target_pos.y>0)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-7,opp_next_pos.y-8));
  else if(target_pos.x>0)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-10,opp_next_pos.y));
  
  else if(target_pos.absY()<3 && target_pos.x<-29.5 && target_pos.x>=-37 && bodyval 
    && opponent_baller->body().isWithin(95,165) &&  wm.self().pos().x<=target_pos.x
    && target_pos.y>-1
  )
    mark_seg.assign(opp_next_pos,Vector2D(ServerParam::i().pitchHalfLength(),3));
  
  else if(target_pos.absY()<3 && target_pos.x<-29.5 && target_pos.x>=-37 && bodyval 
    && opponent_baller->body().isWithin(-165,-95) &&  wm.self().pos().x<=target_pos.x
    && target_pos.y<1
  )
    mark_seg.assign(opp_next_pos,Vector2D(ServerParam::i().pitchHalfLength(),-3));
  
    
  else if(target_pos.absY()<3 && target_pos.x<0 && target_pos.x>=-37)
    mark_seg.assign(opp_next_pos,Vector2D(ServerParam::i().pitchHalfLength(),0.0));
     
    
  
  else if(target_pos.absY()>=15 && target_pos.absY()<=25 && target_pos.y<0 && target_pos.absX()<27)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-5,opp_next_pos.y+9));
  else if (target_pos.absY()>=15 && target_pos.absY()<=25 && target_pos.y>0 && target_pos.absX()<27)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-5,opp_next_pos.y-9));
  else if(target_pos.absY()>=15 && target_pos.y<0 && target_pos.absY()>25 && target_pos.absX()<27)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-0,opp_next_pos.y+10));
  else if (target_pos.absY()>=15 && target_pos.y>0 && target_pos.absY()>25 && target_pos.absX()<27)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-0,opp_next_pos.y-10));
  
  else if(target_pos.absY()>=15 && target_pos.y<0 && target_pos.absY()>25 && target_pos.x>-33 && target_pos.x<=0
    && bodyval && opponent_baller->body().isWithin(10,105) 
    && wm.self().pos().x<=target_pos.x
  )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y+12));
  else if (target_pos.absY()>=15 && target_pos.y>0 && target_pos.absY()>25 && target_pos.x>-33 && target_pos.x<=0
     && bodyval && opponent_baller->body().isWithin(-105,-10) 
    && wm.self().pos().x<=target_pos.x
  )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y-12));
  
  else if(target_pos.absY()>=15 && target_pos.y<0 && target_pos.absY()>25 && target_pos.x>-33 && target_pos.x<=0)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-5,opp_next_pos.y+9));
  else if (target_pos.absY()>=15 && target_pos.y>0 && target_pos.absY()>25 && target_pos.x>-33 && target_pos.x<=0)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-5,opp_next_pos.y-9));
  
  ///////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()>=15 && target_pos.y<0 && target_pos.absY()>22 && target_pos.x>-44 && target_pos.x<=0 
    && bodyval && opponent_baller->body().isWithin(10,100) 
    && wm.self().pos().x<=target_pos.x )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y+12));
  else if (target_pos.absY()>=15 && target_pos.y>0 && target_pos.absY()>22 && target_pos.x>-44 && target_pos.x<=0 
    && bodyval && opponent_baller->body().isWithin(-100,-10) 
    && wm.self().pos().x<=target_pos.x )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y-12));
  ////////////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()>=15 && target_pos.y<0 && target_pos.absY()>22 && target_pos.x>-48 && target_pos.x<=0 
         && bodyval && opponent_baller->body().isWithin(165,-170)
	 && wm.self().pos().x>=target_pos.x)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-7,opp_next_pos.y+3));
  else if (target_pos.absY()>=15 && target_pos.y>0 && target_pos.absY()>22 && target_pos.x>-48 && target_pos.x<=0 
          && bodyval && opponent_baller->body().isWithin(165,-170)
	  && wm.self().pos().x>=target_pos.x)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-7,opp_next_pos.y-3));
  
  ////////////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()>=15 && target_pos.y<0 && target_pos.absY()>22 && target_pos.x>-48 && target_pos.x<=0 
         && bodyval && opponent_baller->body().isWithin(-15,15)
	 && wm.self().pos().x<=target_pos.x)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x,opp_next_pos.y+12));
  else if (target_pos.absY()>=15 && target_pos.y>0 && target_pos.absY()>22 && target_pos.x>-48 && target_pos.x<=0 
          && bodyval && opponent_baller->body().isWithin(-15,15)
	  && wm.self().pos().x<=target_pos.x)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x,opp_next_pos.y-12));
////////////////////////////////////////////////////    
  else if(target_pos.absY()>=15 && target_pos.y<0 && target_pos.absY()>22 && target_pos.x>-48 && target_pos.x<=0)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-10,opp_next_pos.y+8));
  else if (target_pos.absY()>=15 && target_pos.y>0 && target_pos.absY()>22 && target_pos.x>-48 && target_pos.x<=0)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-10,opp_next_pos.y-8));
  
 /////////////////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()>=11 && target_pos.y<0 && target_pos.x<=-27 && target_pos.x>=-34
          && bodyval && opponent_baller->body().isWithin(65,-65)
         )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-6.5,opp_next_pos.y+4));
  else if (target_pos.absY()>=11 && target_pos.y>0 && target_pos.x<=-27 && target_pos.x>=-34
           && bodyval && opponent_baller->body().isWithin(65,-65)
          )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-6.5,opp_next_pos.y-4));  
 //////////////////////////////////////////////////////////////////////////////////////
  
  
  else if(target_pos.absY()>=11 && target_pos.y<0 && target_pos.x<=-27 && target_pos.x>=-34)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),-1.0));
  else if (target_pos.absY()>=11 && target_pos.y>0 && target_pos.x<=-27 && target_pos.x>=-34)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),1.0));
  else if(target_pos.absY()<=3 && target_pos.y<0 && target_pos.x<= -37)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),0));
  else if(target_pos.absY()<=3 && target_pos.y>0 && target_pos.x<= -37)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),0));
  
  //////////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()<=13 && target_pos.y<0 && target_pos.x<= -31 && target_pos.x >= -42
    && bodyval && opponent_baller->body().isWithin(-179,-150)
  )
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),-2.5));
  else if(target_pos.absY()<=13 && target_pos.y>0 && target_pos.x<= -31 && target_pos.x >= -42
    && bodyval && opponent_baller->body().isWithin(150,179)
  )
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),2.5));    
  ////////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()<=13 && target_pos.y<0 && target_pos.x<= -31 && target_pos.x >= -42)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),+2.5));
  else if(target_pos.absY()<=13 && target_pos.y>0 && target_pos.x<= -31 && target_pos.x >= -42)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),-2.5));
  /////////////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()>=8 && target_pos.absY()<=22 && target_pos.y<0 && target_pos.x<= -31 
         && target_pos.x >= -42 && bodyval && opponent_baller->body().isWithin(10,108)
	 && wm.self().pos().x<=target_pos.x)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-0.5,opp_next_pos.y+12));
  else if(target_pos.absY()>=8 && target_pos.absY()<=22 && target_pos.y>0 && target_pos.x<= -31 
         && target_pos.x >= -42 && bodyval && opponent_baller->body().isWithin(-108,-10)
	 && wm.self().pos().x<=target_pos.x)
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-0.5,opp_next_pos.y+12));
  
  else if(target_pos.absY()>=8 && target_pos.absY()<=21 && target_pos.y<0 && target_pos.x<= -31 
         && target_pos.x >= -42)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),-2));
  else if(target_pos.absY()>=8 && target_pos.absY()<=21 && target_pos.y>0 && target_pos.x<= -31 
         && target_pos.x >= -42)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),2));
  
  
  ///////////////////////////////////////////////////////////////////////////////////////
  
///////////////////////////////////////////////////////////////////////////////////////
  else if(target_pos.absY()<=13 && target_pos.y<0 && target_pos.x<= -42 && target_pos.x >= -49
    && target_pos.absY()>6 && bodyval && opponent_baller->body().isWithin(10,95) 
    && wm.self().pos().x < target_pos.x
  )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-1.5,+12));
  else if(target_pos.absY()<=13 && target_pos.y>0 && target_pos.x<= -42 && target_pos.x >= -49
     && target_pos.absY()>6 && bodyval && opponent_baller->body().isWithin(-95,-10) 
    && wm.self().pos().x < target_pos.x
  )
    mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-1.5,-12));
/////////////////////////////////////////////////////////////////////////////////////    
  else if(target_pos.absY()<=13 && target_pos.y<0 && target_pos.x<= -42 && target_pos.x >= -49)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),-1));
  else if(target_pos.absY()<=13 && target_pos.y>0 && target_pos.x<= -42 && target_pos.x >= -49)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),+1));
  
   else if(target_pos.absY()<=15 && target_pos.y<0 && target_pos.x<= -48)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),+0.3));
  else if(target_pos.absY()<=15 && target_pos.y>0 && target_pos.x<= -48)
    mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),-0.3));
  
  else if (target_pos.x<=-42 && target_pos.x>=-52)
  {
    if (target_pos.y<0  && bodyval && opponent_baller->body().isWithin(10,100)
      && wm.self().pos().x<=target_pos.x
    )
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-0.75,opp_next_pos.y+12));
    else if(target_pos.y>0 && bodyval && opponent_baller->body().isWithin(-100,-10)
      && wm.self().pos().x<=target_pos.x
    )
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-0.75,opp_next_pos.y-12));
    else if (target_pos.y<0)
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-5,opp_next_pos.y+12));
    else
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-5,opp_next_pos.y-12));
  }
  else if (target_pos.x<-49)
  {
    if (target_pos.y<0  && bodyval && opponent_baller->body().isWithin(10,100)
      && wm.self().pos().x<=target_pos.x
    )
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y+18));
    else if(target_pos.y>0 && bodyval && opponent_baller->body().isWithin(-100,-10)
      && wm.self().pos().x<=target_pos.x
    )
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-2,opp_next_pos.y-18));
    else if (target_pos.y<0)
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-3,opp_next_pos.y+15));
    else
      mark_seg.assign(opp_next_pos,Vector2D(opp_next_pos.x-3,opp_next_pos.y-15));
  }
  
  else if(target_pos.y>=0 && target_pos.absY()<15)
  mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),0));
  
  else if(target_pos.y<0 && target_pos.absY()<15)
  mark_seg.assign(opp_next_pos,Vector2D(-ServerParam::i().pitchHalfLength(),0));
  
  if((wm.self().unum() ==2 || wm.self().unum() == 3) && target_pos.x<0 && target_pos.x>-37 && target_pos.absY()<4)
  {
    if( markCircle_6.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
           {
             vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];
	   }
	   else
	     vec_block=Strategy::i().getPosition(wm.self().unum());
    
    
  }
  
  else if(target_pos.x<-38.5  && target_pos.absY()<10)
  {
    if( markCircle_D.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
           {
             vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];
	   }
	   else
	     vec_block=Strategy::i().getPosition(wm.self().unum());
    
  }
  
  else if (target_pos.x<-40)
  {
     if( markCircle_2.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
           {
             vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];
	   }
	   else
	     vec_block=Strategy::i().getPosition(wm.self().unum());
  }
  else
  {
    if(target_pos.absX()>20)
    {
     if( markCircle.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
           {
             vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];
	   }
	   else
	     vec_block=Strategy::i().getPosition(wm.self().unum());
     }
     else
     {
       if( markCircle_5.intersection( mark_seg , &intersectPoint[0] , &intersectPoint[1] ) == 1 )
           {
             vec_block = ( intersectPoint[0].isValid() ) ? intersectPoint[0] : intersectPoint[1];
	   }
	   else
	     vec_block=Strategy::i().getPosition(wm.self().unum());
       
    }
  }
  return vec_block;

 }


