/*
 *   <one line to give the program's name and a brief idea of what it does.>
 *   Copyright (C) 2011 Shahin Bulouki & Mohammadhosein Malmir & Amirahmad Barekatein  <sh.boluki@gmail.com>  & <mhmalmir@gmail.com> & <amirahmad.barekatein@gmail.com>
 * 
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 * 
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef BHV_MARK_ACTION_H
#define BHV_MARK_ACTION_H


#include "bhv_mark.h"
#include <rcsc/geom/vector_2d.h>
#include <rcsc/player/soccer_action.h>
#include <vector>
#include <rcsc/player/player_agent.h>
#include <rcsc/common/server_param.h>
#include "strategy.h"
#include <rcsc/math_util.h>
#include <rcsc/common/server_param.h>
#include <rcsc/geom/composite_region_2d.h>
#include <rcsc/action/basic_actions.h>
#include <rcsc/action/bhv_go_to_point_look_ball.h>
#include <rcsc/action/body_go_to_point.h>

using namespace std ;
class Bhv_Mark_Action
: public rcsc::SoccerBehavior
{
public :
  Bhv_Mark_Action( int target_opponent_unum ) : 
  target_opp_unum(target_opponent_unum )
  {
  }
  virtual bool execute ( PlayerAgent * agent ) {}
  bool markActionExecute( PlayerAgent * agent , Vector2D & targetPoint , double & dashPower );
  
  enum MarkType
  {
    MARK_PASS ,
    MARK ,
    POSITIONING ,
    NONE
  };
  
  struct MarkRoute
  {
    MarkType mark_type_;
    Vector2D target_pos_;
    double   dash_power ;
  };
  
private :
  
  int       target_opp_unum ; 
  bool      first_guarding  ;
  static Vector2D last_m_pos ;
  static Vector2D last_m_dead;
  static int unums[12][12];
  //Vector2D temp_pos=Vector2D(0.0,0.0);
  Vector2D temp_pos;
  
  MarkRoute markPass     ( PlayerAgent * agent );
  MarkRoute mark	       ( PlayerAgent * agent );
  
  
  MarkRoute getBestMarkAction( PlayerAgent * agent );
  double getMarkTypeScore    ( PlayerAgent * agent , MarkType mark_type );
  
};
#endif // BHV_BLOCK_H