/*!
    <Bhv Pass Class.>
    Copyright (C) 2011  <Hessamoddin Hediehloo> <olampiad1370@yahoo.com> , <Mohammad Simchi> <m.simchi@yahoo.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BHV_PASS_H_
#define BHV_PASS_H_

#include "pass_object.h"

#include <rcsc/player/soccer_action.h>

#include <rcsc/action/body_kick_one_step.h>
#include "rcsc/action/body_smart_kick.h"
#include "rcsc/action/body_stop_ball.h"
#include "rcsc/action/body_hold_ball2008.h"

#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>
#include <rcsc/player/audio_sensor.h>
#include <rcsc/player/say_message_builder.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>
#include <rcsc/geom/rect_2d.h>
#include <rcsc/geom/line_2d.h>
#include <rcsc/geom/sector_2d.h>
#include <rcsc/soccer_math.h>
#include <rcsc/math_util.h>
#include <rcsc/common/audio_memory.h>
#include <rcsc/player/intercept_table.h>
using namespace rcsc;

class Bhv_Pass 
    : public rcsc::SoccerBehavior {
public:
	Bhv_Pass() {}
	
	bool execute( PlayerAgent * agent );

	bool passExecute( PlayerAgent * agent , Vector2D pass_target , double first_speed );

	bool virtualPassExecute( PlayerAgent * agent , Vector2D & pass_target , double & first_speed );
	
private:
  void defPassPos( PlayerAgent * agent , PlayerObject * receiver );
  void midPassPos( PlayerAgent * agent , PlayerObject * receiver );
  void attPassPos( PlayerAgent * agent , PlayerObject * receiver );
  
  double getFirstSpeed( PlayerAgent* agent , Vector2D target );
  
  void clear();
  
  PassObject getBestPass( PlayerAgent * agent );
  
  static std::vector< PassObject > cached_pass_objects;

    static PassObject M_cached_pass;
   
};

#endif 
