/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 2012  Mohammadhossein Malmir <email>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef ESCAPEOBJECT_H
#define ESCAPEOBJECT_H

#include "strategy.h"

#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>
#include <rcsc/player/audio_sensor.h>
#include <rcsc/player/say_message_builder.h>
#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>
#include <rcsc/geom/rect_2d.h>
#include <rcsc/geom/line_2d.h>
#include <rcsc/geom/sector_2d.h>
#include <rcsc/soccer_math.h>
#include <rcsc/math_util.h>
#include <rcsc/common/audio_memory.h>


class Escape_Object
{
protected:
    rcsc::PlayerAgent * M_agent;
    rcsc::Vector2D M_position;
    double M_score;
    
public:
    Escape_Object();

    Escape_Object( rcsc::PlayerAgent * agent,
                       const rcsc::Vector2D pos );

    const rcsc::Vector2D Position() { return M_position; }
    double Score() { return M_score; }
    void compute();
    double distToTarget();
    double distToBall();
};

#endif // ESCAPEOBJECT_H
