/*!
    <SimMal Dribble Class.>
    Copyright (C) 2011  <Mohammadhossein Malmir> <mhmalmir@gmail.com> , <Mohammad Simchi> <m.simchi@yahoo.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SIMMALDRIBBLE_H
#define SIMMALDRIBBLE_H

#include <rcsc/player/soccer_action.h>

#include <rcsc/player/player_agent.h>

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>

class SimMalDribble 
      : public rcsc::SoccerBehavior
{
private :
  static int last_cycle ;
  
public :
  
  SimMalDribble( )
		  { }
		  
  bool execute( rcsc::PlayerAgent * agent )
  { 
	rcsc::Vector2D SM_target_point ;
	double SM_dist_thr ;
	double SM_dash_power ;
	int SM_dash_count ;
	bool SM_dodge ;
	bool SM_speedy ;
	bool SM_Danger;
	
	if ( virtualDribbleExecute( agent , false , SM_target_point , SM_dist_thr , SM_dash_power , SM_dash_count , SM_dodge , SM_speedy , SM_Danger ) )
	  return dribbleExecute( agent , SM_target_point , SM_dist_thr , SM_dash_power , SM_dash_count , SM_dodge , SM_speedy , SM_Danger );
	
	return false;
  }
  
  bool dribbleExecute( rcsc::PlayerAgent * agent ,
		       rcsc::Vector2D SM_target_point ,
		       double SM_dist_thr ,
		       double SM_dash_power ,
		       int SM_dash_count ,
		       bool SM_dodge ,
		       bool SM_speedy, 
		       bool SM_Danger);
  
  bool virtualDribbleExecute( rcsc::PlayerAgent * agent ,
			      bool pass,
			      rcsc::Vector2D & SM_target_point ,
			      double & SM_dist_thr ,
			      double & SM_dash_power ,
			      int & SM_dash_count ,
			      bool & SM_dodge ,
			      bool & SM_speedy, 
		              bool &SM_Danger );
  
  bool virtualFastDribbleExecute( rcsc::PlayerAgent * agent ,
				  rcsc::Vector2D & SM_target_point ,
				  double & SM_dist_thr ,
				  double & SM_dash_power ,
				  int & SM_dash_count ,
				  bool & SM_dodge ,
				  bool & SM_speedy , 
		              bool &SM_Danger );
  
  static int cyclesObjectToReachPos( rcsc::PlayerAgent * agent , rcsc::PlayerObject * o , rcsc::Vector2D pos , bool is_self );
  
  rcsc::Polygon2D tackleArea( rcsc::PlayerObject * o );
  
  rcsc::Vector2D getInLand( rcsc::Vector2D pos , rcsc::AngleDeg th , double r_max , double r_min );

  static bool isInLand( rcsc::Vector2D pos );
  
  bool opponentsCanReachToBall( rcsc::PlayerAgent * agent , rcsc::Vector2D pos );


private:
  
  bool Dribble ( rcsc::PlayerAgent * agent ,
		    rcsc::Vector2D & SM_target_point ,
		    double & SM_dist_thr ,
		    double & SM_dash_power ,
		    int & SM_dash_count ,
		    bool & SM_dodge ,
		    bool & SM_speedy , 
		              bool &SM_Danger );

  rcsc::Vector2D dodgePoint ( rcsc::PlayerAgent * agent , int step , double length );
  rcsc::Vector2D penalty_mode_dribble ( rcsc::PlayerAgent * agent );
  
  rcsc::AngleDeg baseAngle( rcsc::PlayerAgent * agent , rcsc::Vector2D mypos );
  
  bool M_pass;

};

#endif // SIMMALDRIBBLE_H
